﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace crypto
{
    class Week5
    {
        //Which of the following numbers is a generator of Z13∗?
        //8,⟨8⟩={1,8,12,5}
        //4,⟨4⟩={1,4,3,12,9,10}
        //2,⟨2⟩={1,2,4,8,3,6,12,11,9,5,10,7}
        //7,⟨7⟩={1,7,10,5,9,11,12,6,3,8,4,2}
        //3,⟨3⟩={1,3,9}
        private void PrintSet(List<int> set)
        {
            for (int i = 0; i < set.Count; i++)
            {
                Console.Write("{0}, ", set[i]);
            }
        }
        public bool IsGenerator(int g, int prime, List<int> set, bool print)
        {
            bool isGen = false;
            //Array of list of ints
            List<int> cyclicSet = new List<int>(prime - 1);
            for (int i = 1; i < prime; i++)
            {
                cyclicSet.Add(i);
            }

            if (cyclicSet.Intersect(set).Count() == cyclicSet.Count)
            {
                isGen = true;
            }

            if (print)
            {
                Console.WriteLine("Generator = {0}, \ntest set: ", g);
                this.PrintSet(set);
                Console.WriteLine("\nGenerated Set:");
                this.PrintSet(cyclicSet);
                Console.WriteLine("\nReturning: {0}\n============", isGen);
            }

            return isGen;
        }

        public int GetOrder(int generator, int baseNum)
        {
            int exponent = 1;
            while (Math.Pow(generator, exponent) % baseNum != 1)
            {
                exponent++;
            }
            return exponent;
        }

        public int GetSquareRoot(int number, int primeBase)
        {
            int root = 1;
            while ((int)Math.Pow(root, 2) % primeBase != number)
            {
                root++;
            }
            return root;
        }

        public double GetMultiplier(int x, int baseNum, int result)
        {
            int i=1;
            //Num of elements in set with baseNum
            while (Math.Pow (x, i) % baseNum != result)
            {
                i++;
            }
            return Math.Pow (x, i-1) % baseNum;
        }
    }

    class Crypto
    {
        static void Main(string[] args)
        {
            Week5 w = new Week5();
//            int prime = 13;
//            bool printSets = true;
//            w.IsGenerator(6, prime, new List<int>() {1,6,10,8,9,2,12,7,3,5,4,11}, printSets);
//            w.IsGenerator(4, prime, new List<int>() {1,4,3,12,9,10}, printSets);
//            w.IsGenerator(3, prime, new List<int>() {1,3,9}, printSets);
//            w.IsGenerator(8, prime, new List<int>() {1,8,12,5}, printSets);
//            w.IsGenerator(7, prime, new List<int>() {1,7,10,5,9,11,12,6,3,8,4,2}, printSets);
            
//            Console.WriteLine("Order of 2 in Z35: ", w.GetOrder(2, 35));

//            Console.WriteLine("Square root of 12 in Z23 is {0}", w.GetSquareRoot(12, 23));
//            Console.WriteLine ("Inverse of {0} in Z{1} is: {2}", 7, 23, w.GetMultiplier(7, 23, 1));
            Console.WriteLine("Inverse of 3, such that 3x=5 in Z19 is {0}", w.GetMultiplier(3, 19, 5));
            Console.ReadKey();
        }
    }
}
